# Use md5
%define _binary_filedigest_algorithm 1

%define _binary_payload w9.gzdio

# Metadata
Name: td-agent
Version: 2.3.4
Release: 0.el7
Summary:  Treasure Agent: A data collector for Treasure Data
BuildRoot: %buildroot
Prefix: /
Group: System Environment/Daemons
License: Apache-2.0
Vendor: Treasure Data, Inc.
URL: http://treasuredata.com
Source: %{name}-%{version}.tar.gz
Patch1: fix-download-failure.patch 
Requires: initscripts
Requires: redhat-lsb-core
Provides: libiconv.so.2()(64bit) 
BuildRequires: autoconf rh-ruby23-ruby-devel rh-ruby23-rubygem-bundler git sudo
%description
Treasure Agent: A data collector for Treasure Data

%prep
%setup -q
%patch1 -p1

%build
sudo mkdir -p /opt/td-agent /var/cache/omnibus
scl enable rh-ruby23 "bundle install --binstubs; \
bundle config github.https true; \
bin/gem_downloader core_gems.rb; \
bin/gem_downloader plugin_gems.rb; \
bin/gem_downloader ui_gems.rb; \
bin/omnibus build td-agent2;"

%install
install -m 755 -d $RPM_BUILD_ROOT/opt/td-agent
cp -p -rda /opt/td-agent/* $RPM_BUILD_ROOT/opt/td-agent

%clean
rm -rf $RPM_BUILD_ROOT
%post
td_agent_dir=/opt/td-agent

echo "adding 'td-agent' group..."
getent group td-agent >/dev/null || /usr/sbin/groupadd -r td-agent
echo "adding 'td-agent' user..."
getent passwd td-agent >/dev/null || \
  /usr/sbin/useradd -r -g td-agent -d /var/lib/td-agent -s /sbin/nologin -c 'td-agent' td-agent

if [ ! -e "/var/log/td-agent/" ]; then
  mkdir -p /var/log/td-agent/
fi
chown -R td-agent:td-agent /var/log/td-agent/

if [ ! -e "/var/run/td-agent/" ]; then
  mkdir -p /var/run/td-agent/
fi
chown -R td-agent:td-agent /var/run/td-agent/

if [ ! -e "/etc/td-agent/" ]; then
  mkdir -p /etc/td-agent/
  mkdir -p /etc/td-agent/plugin
fi
if [ ! -e "/etc/td-agent/td-agent.conf" ]; then
  echo "Installing default conffile..."
  cp -f ${td_agent_dir}/etc/td-agent/td-agent.conf.tmpl /etc/td-agent/td-agent.conf
fi

# 2011/11/13 Kazuki Ohta <k@treasure-data.com>
# This prevents prelink, to break the Ruby intepreter.
if [ -d "/etc/prelink.conf.d/" ]; then
  echo "prelink detected. Installing /etc/prelink.conf.d/td-agent-ruby.conf ..."
  cp -f ${td_agent_dir}/etc/td-agent/prelink.conf.d/td-agent.conf /etc/prelink.conf.d/td-agent-ruby.conf
elif [ -f "/etc/prelink.conf" ]; then
  if [ $(grep '\-b ${td_agent_dir}/embedded/bin/ruby' -c /etc/prelink.conf) -eq 0 ]; then
    echo "prelink detected, but /etc/prelink.conf.d/ dosen't exist. Adding /etc/prelink.conf ..."
    echo "-b ${td_agent_dir}/embedded/bin/ruby" >> /etc/prelink.conf
  fi
fi

# 2013/03/04 Kazuki Ohta <k@treasure-data.com>
# Install log rotation script.
if [ -d "/etc/logrotate.d/" ]; then
  cp -f ${td_agent_dir}/etc/td-agent/logrotate.d/td-agent.logrotate /etc/logrotate.d/td-agent
fi

# 2011/11/13 Kazuki Ohta <k@treasure-data.com>
# Before td-agent v1.1.0, fluentd has a bug of loading plugin before changing
# to the right user. Then, these directories were created with root permission.
# The following lines fix that problem.
if [ ! -e "/var/log/td-agent/buffer/" ]; then
  mkdir -p /var/log/td-agent/buffer/
fi
if [ -d "/var/log/td-agent/buffer/" ]; then
  chown -R td-agent:td-agent /var/log/td-agent/buffer/
fi
if [ ! -e "/tmp/td-agent/" ]; then
  mkdir -p /tmp/td-agent/
fi
if [ -d "/tmp/td-agent/" ]; then
  chown -R td-agent:td-agent /tmp/td-agent/
fi

cp -f ${td_agent_dir}/etc/init.d/td-agent /etc/init.d/td-agent
cp -f ${td_agent_dir}/usr/sbin/td-agent /usr/sbin/td-agent
chmod 755 /usr/sbin/td-agent
cp -f ${td_agent_dir}/usr/sbin/td-agent-gem /usr/sbin/td-agent-gem
chmod 755 /usr/sbin/td-agent-gem
if [ -f ${td_agent_dir}/usr/sbin/td-agent-ui ]; then
    cp -f ${td_agent_dir}/usr/sbin/td-agent-ui /usr/sbin/td-agent-ui
    chmod 755 /usr/sbin/td-agent-ui
fi
if [ -f ${td_agent_dir}/usr/bin/td ]; then
    cp -f ${td_agent_dir}/usr/bin/td /usr/bin/td
    chmod 755 /usr/bin/td
fi

echo "Configure td-agent to start, when booting up the OS..."
/sbin/chkconfig --add td-agent

# 2011/03/24 Kazuki Ohta <k@treasure-data.com>
# When upgrade, restart agent if it's launched
if [ "$1" = "2" ]; then
  /sbin/service td-agent condrestart >/dev/null 2>&1 || :
fi

%preun
# 2011/02/21 Kazuki Ohta <k@treasure-data.com>
# Just leave this file, because this line could delete td-agent.conf in a
# *UPGRADE* process :-(
# if [ -e "/etc/prelink.conf.d/td-agent-ruby.conf" ]; then
#   echo "Uninstalling /etc/prelink.conf.d/td-agent-ruby.conf ..."
#   rm -f /etc/prelink.conf.d/td-agent-ruby.conf
# fi
if [ $1 = 0 ] ; then
  echo "Stopping td-agent ..."
  /sbin/service td-agent stop >/dev/null 2>&1 || :
  /sbin/chkconfig --del td-agent
fi

%postun


%files
%defattr(-,root,root,-)
%dir %attr(0755,root,root) /opt
%dir /opt/td-agent
/opt/td-agent/*

%changelog
* Thu Mar 30 2017 Tianyue Lan <tianyue.lan@oracle.com> - 2.3.4-1.el7 
- v2.3.4
- Added fix-download-failure.patch 

